<template>
  <div>
    <div class="fr-col-lg-8">
      <img
        class="anct-not-printable"
        :src="post.image"
        alt="post-logo"
        style="width: 282px"
      />
      <FrTitle larger class="fr-my-6w anct-printable-content">
        {{ post.title }}
      </FrTitle>

      <FrDownloadPage class="anct-not-printable" />

      <section
        id="post-content"
        class="fr-mb-6w anct-html-content anct-printable-content"
        v-html="post.content"
      />
    </div>

    <section
      v-if="alternativePosts.length"
      id="alternative-posts"
      class="anct-not-printable"
    >
      <p class="anct-flex-between">
        <strong class="fr-text--xl"
          >D’autres actualités peuvent vous interesser</strong
        >
        <nuxt-link
          :to="{ name: 'actualites' }"
          class="fr-link fr-icon-arrow-right-line fr-link--icon-right"
          >Tout voir</nuxt-link
        >
      </p>

      <div class="fr-container fr-px-0">
        <FrCardsContainer class="fr-mx-0">
          <FrCard
            v-for="(alternativePost, index) in alternativePosts"
            :key="`alternative-post${index}`"
            class="fr-col-4"
            :to="alternativePost.to"
            :title="alternativePost.title"
            :description="alternativePost.description"
            :detail="alternativePost.detail"
            :image-path="alternativePost.image"
            enlarge-link
          />
        </FrCardsContainer>
      </div>
    </section>
  </div>
</template>

<script>
import FrTitle from '~/components/ui/Title';
import FrCard from '~/components/elements/Card';
import FrCardsContainer from '~/components/elements/CardsContainer';
import FrDownloadPage from '~/components/elements/DownloadPage';
import { DEFAULT_DATE_FORMAT, LOCALE } from '~/config/locale';

export default {
  name: 'NewsItemPage',

  components: { FrTitle, FrCard, FrCardsContainer, FrDownloadPage },

  async asyncData({ $axios, params, $config, redirect }) {
    const { data } = await $axios.$get('/items/actualites', {
      params: {
        fields: 'title,content,image',
        filter: { slug: { _eq: params.slug }, status: { _eq: 'published' } },
      },
    });

    const { data: dataB } = await $axios.$get('/items/actualites', {
      params: {
        fields: 'id,title,description,image,slug,publication_date',
        limit: 3,
        filter: { slug: { _neq: params.slug }, status: { _eq: 'published' } },
        sort: '-publication_date',
      },
    });

    const alternativePosts = dataB.map(
      ({ title, description, image, slug, publication_date }) => {
        const detail = new Date(publication_date).toLocaleString(
          LOCALE,
          DEFAULT_DATE_FORMAT,
        );

        return {
          detail,
          title,
          description,
          image: image
            ? `${$config.apiURL}/assets/${image}`
            : `${$config.apiURL}/assets/bee81aba-da05-4390-9cf0-f88591df9267`,
          to: { name: 'actualites-slug', params: { slug } },
        };
      },
    );

    const [post] = data;

    if (!post) {
      return redirect({ name: 'actualites' });
    }

    post.image = post.image
      ? `${$config.apiURL}/assets/${post.image}`
      : `${$config.apiURL}/assets/bee81aba-da05-4390-9cf0-f88591df9267`;

    return { post, alternativePosts };
  },

  data() {
    return {
      post: {},
      alternativePosts: [],
    };
  },
};
</script>

<style scoped>
/deep/ #post-content a {
  color: var(--text-title-blue-france);
}

/deep/ .anct-html-content blockquote {
  margin-left: 0;
  border-left: 4px solid var(--blue-france-main-525);
  padding-left: 16px;
}

/deep/ .anct-html-content blockquote p {
  margin-bottom: 0;
}

/deep/ .anct-html-content blockquote p strong {
  font-weight: normal;
}

/deep/ .anct-html-content ul,
/deep/ .anct-html-content ol {
  margin-left: 24px;
  margin-bottom: 16px;
}

/deep/ .anct-html-content ul p {
  margin-bottom: 8px;
}

/deep/ .anct-html-content h2 {
  margin-top: 48px;
}

#alternative-posts > p {
  border-bottom: 1px solid #e5e5e5;
}
</style>
